local WhoRollFu, self = WhoRollFu, WhoRollFu

local AceConfigDialog = LibStub("AceConfigDialog-3.0")

local L = LibStub("AceLocale-3.0"):GetLocale("LootRoll")

local function getOptions()
	if not self.options then
		self.options = {
			name = "FuBar_WhoRollFu",
			desc = "FuBar_WhoRollFu",
			handler = LootRoll,
			type = 'group',
			args = {
				fubar = {
					type = "group",
					name = "FuBar options",
					desc = "FuBar options",
					args = {
						showIcon = {
							type = "toggle",
							name = L["Show icon"],
							desc = L["Show icon"],
							get = function(info) return self:IsFuBarIconShown() end,
							set = function(info, v) self:ToggleFuBarIconShown() end,
						},
						showText = {
							type = "toggle",
							name = "Show text",
							desc = "Show text",
							get = function(info) return self:IsFuBarTextShown() end,
							set = function(info, v) self:ToggleFuBarTextShown() end,
						},
						position = {
							type = "select",
							name = L["Position"],
							desc = L["Position"],
							values = {LEFT = L["Left"], CENTER = L["Center"], RIGHT = L["Right"]},
							get = function() return self:GetPanel() and self:GetPanel():GetPluginSide(self) end,
							set = function(info, val)
								if self:GetPanel() and self:GetPanel().SetPluginSide then
									self:GetPanel():SetPluginSide(self, val)
								end
							end,
						}
					},
				},
			}
		}
	end
	return self.options
end

function WhoRollFu:ShowConfig()
	AceConfigDialog:SetDefaultSize("FuBar_WhoRollFu", 500, 300)
	AceConfigDialog:Open("FuBar_WhoRollFu")
end

function WhoRollFu:InitOptions()
	
	LibStub("AceConfig-3.0"):RegisterOptionsTable("FuBar_WhoRollFu", getOptions, "whorollfu")
	self.OnMenuRequest = self.options
	self.OpenMenu = self.ShowConfig
	AceConfigDialog:AddToBlizOptions("FuBar_WhoRollFu", "FuBar_WhoRollFu")
	
end