-- displays data gathered by the core in FuBar

local WhoRollFu, self = WhoRollFu, WhoRollFu

local Tablet = LibStub("Tablet-2.0")

local L = LibStub("AceLocale-3.0"):GetLocale("LootRoll")

--FuBar-stuff
LibStub("AceAddon-3.0"):EmbedLibrary(WhoRollFu, "LibFuBarPlugin-Mod-3.0")

-- globals
local _G = _G
local NEED = _G.NEED
local GREED = _G.GREED
local PASS = _G.PASS
local GetItemInfo = _G.GetItemInfo
local GetItemQualityColor = _G.GetItemQualityColor
local UnitInRaid = _G.UnitInRaid
local UnitInParty = _G.UnitInParty
local GetNumPartyMembers = _G.GetNumPartyMembers
local GetNumRaidMembers = _G.GetNumRaidMembers
local UnitName = _G.UnitName

local lootIcons = {
	[NEED] = [[Interface/Buttons/UI-GroupLoot-Dice-Up]],
	[GREED] = [[Interface/Buttons/UI-GroupLoot-Coin-Up]],
	[PASS] = [[Interface/Buttons/UI-GroupLoot-Pass-Up]], --?
}

function WhoRollFu:SetupFuBar()

	if LibStub:GetLibrary("LibFuBarPlugin-Mod-3.0") then
		self:SetFuBarText("WhoRollFu")
		self:SetFuBarOption('tooltipType', "Tablet-2.0")
		self:SetFuBarOption('hasIcon', true)
		self:SetFuBarOption('iconPath', [[Interface/Buttons/UI-GroupLoot-Dice-Up]])
	end
	
end

local function addLootLineToCat(cat, loot, name)
	local line = {
		['text'] = name,
		['text2'] = loot.rolls[name] or "-",
		['hasCheck'] = true,
		['checked'] = loot.rolls[name],
		['checkIcon'] = lootIcons[loot.rolls[name]],
	}
	cat:AddLine(line)
end

function WhoRollFu:OnUpdateFuBarTooltip()
	
	for k,v in pairs(self.currentLoots) do
		local _, _, quality, _, _, _, _,_,_, texture = GetItemInfo(k)
		local r,g,b,hex = GetItemQualityColor(quality)

		local cat = Tablet:AddCategory(
			'columns', 2,
			'text', GetItemInfo(k),
			'textR', r,
			'textG', g,
			'textB', b,
			'showWithoutChildren', true,
			'hasCheck', true,
			'checked', true,
			'checkIcon', texture
		)
		
		if UnitInRaid("player") then
			for i = 1,GetNumRaidMembers() do
				local name = UnitName("raid" .. i)
				addLootLineToCat(cat, v, name)
			end
		elseif UnitInParty("player") then
			local name = UnitName("player")
			addLootLineToCat(cat, v, name)
			
			for i = 1,GetNumPartyMembers() do
				name = UnitName("party" .. i)
				addLootLineToCat(cat, v, name)
			end
		end
		
	end
	
	Tablet:SetHint("Shows who rolled what type of dice when Group Loot is active")
end
